# std::bad_alloc

From cppreference.com
< cpp‎ | memory‎ | new

Defined in header `<new>` |  |
class bad_alloc; |  |

`std::bad_alloc` is the type of the object thrown as exceptions by the allocation functions to report failure to allocate storage.

Inheritance diagram

### Member functions

(constructor) | constructs the bad_alloc object (public member function)
operator= | replaces a bad_alloc object (public member function)
what | returns explanatory string (public member function)

## std::bad_alloc::bad_alloc

bad_alloc(); |  |

Constructs new `bad_alloc` object with an implementation-defined null-terminated byte string which is accessible through `what()`.

### Parameters

(none)

### Exceptions

(none) | (until C++11)
`noexcept` specification: noexcept | (since C++11)

## std::bad_alloc::operator=

bad_alloc& operator=( const bad_alloc& other ); |  |

Assigns the contents of `other`.

### Parameters

other | - | another exception object to assign

### Return value

*this

### Exceptions

(none) | (until C++11)
`noexcept` specification: noexcept | (since C++11)

## std::bad_alloc::what

virtual const char* what() const; |  |

Returns the explanatory string.

### Parameters

(none)

### Return value

Pointer to a null-terminated string with explanatory information.

### Exceptions

(none) | (until C++11)
`noexcept` specification: noexcept | (since C++11)

## Inherited from std::exception

### Member functions

(destructor) [virtual] | destructs the exception object (virtual public member function of `std::exception`)
what [virtual] | returns an explanatory string (virtual public member function of `std::exception`)

### Example

Run this code

    #include <iostream>
    #include <new>

    int main()
    {
        try {
            while (true) {
                new int[100000000ul];
            }
        } catch (const std::bad_alloc& e) {
            std::cout << "Allocation failed: " << e.what() << '\n';
        }
    }

Possible output:

    Allocation failed: std::bad_alloc

### See also

operator new operator new[] | allocation functions (function)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/memory/new/bad_alloc&oldid=91857"
Category:

- unconditionally noexcept

Hidden categories:

- Pages with unreviewed unconditional noexcept template
- Pages with unreviewed noexcept template